



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ASP.NET MVC请求处理管道生命周期的19个关键环节(13-19)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ASP.NET MVC请求处理管道生命周期的19个关键环节(13-19)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 07:10:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在上一篇"<a href="http://www.cnblogs.com/darrenji/p/3795676.html" rel="external nofollow noreferrer">ASP.NET MVC请求处理管道生命周期的19个关键环节(7-12)</a> "，体验了7-12关键环节，本篇继续。</p>
<p>⒀当请求到达UrlRoutingModule的时候，UrlRoutingModule取出请求中的Controller、Action等RouteData信息，与路由表中的所有规则进行匹配，若匹配，把请求交给IRouteHandler，即MVCRouteHandler</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/417212/201406/190104496146521.png" /></p>
<p>MVCRouteHandler是用来生成实现IHttpHandler接口的MvcHandler：</p>
<div>
<pre class="prettyprint linenums">namespace System.Web.Routing<br />
{<br />
    public interface IRouteHandler<br />
    {<br />
        IHttpHandler GetHttpHandler(RequestContext requestContext);<br />
    }<br />
}</pre>
</div>
<p>UrlRoutingModule如何把请求交给MVCRouteHandler？<br />通过分析UrlRoutingModule的源码可以看到：</p>
<p>//通过RouteCollection的静态方法GetRouteData获取到封装路由信息的RouteData实例<br />RouteData routeData = this.RouteCollection.GetRouteData(context);</p>
<p>//再从RouteData中获取MVCRouteHandler<br />IRouteHandler routeHandler = routeData.RouteHandler;</p>
<p>为什么可以从RouteData中拿到MVCRouteHadnler呢？<br />因为当我们在HttpApplication的第一个管道事件，使用MapRoute()方法注册路由的时候，已经通过Route类的构造函数把MVCRouteHandler注入到路由中了。</p>
<div>
<pre class="prettyprint linenums">public static Route MapRoute(this RouteCollection routes, string name, string url, object defaults, object constraints, string[] namespaces) {<br />
            if (routes == null) {<br />
                throw new ArgumentNullException("routes");<br />
            }<br />
            if (url == null) {<br />
                throw new ArgumentNullException("url");<br />
            }

            Route route = new Route(url, new MvcRouteHandler()) {<br />
                Defaults = new RouteValueDictionary(defaults),<br />
                Constraints = new RouteValueDictionary(constraints),<br />
                DataTokens = new RouteValueDictionary()<br />
            };

            if ((namespaces != null) &amp;&amp; (namespaces.Length &gt; )) {<br />
                route.DataTokens["Namespaces"] = namespaces;<br />
            }

            routes.Add(name, route);

            return route;<br />
        }</pre>
</div>
<p>⒁MVCRouteHandler把请求交给MvcHandler</p>
<p>还是从UrlRoutingModule的源码可以看到，通过HttpHandler的GetHttpHandler()方法获取到了实现了IHttpHandler接口的MVCHandler:</p>
<div>
<pre class="prettyprint linenums">IHttpHandler httpHandler = routeHandler.GetHttpHandler(requestContext);<br />
context.RemapHandler(httpHandler);</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/417212/201406/190104512548523.png" /></p>
<p>MvcHandler的部分源码为：</p>
<div>
<pre class="prettyprint linenums">public class MvcHandler : IHttpAsyncHandler, IHttpHandler, IRequiresSessionState<br />
{<br />
        protected internal virtual void ProcessRequest(HttpContextBase httpContext)<br />
        {<br />
            SecurityUtil.ProcessInApplicationTrust(() =&gt;<br />
            {<br />
                IController controller;<br />
                IControllerFactory factory;<br />
                ProcessRequestInit(httpContext, out controller, out factory);//初始化了ControllerFactory<br />
                try<br />
                {<br />
                    controller.Execute(RequestContext);<br />
                }<br />
                finally<br />
                {<br />
                    factory.ReleaseController(controller);<br />
                }<br />
            });<br />
        }

         private void ProcessRequestInit(HttpContextBase httpContext, out IController controller, out IControllerFactory factory) {<br />
            bool? isRequestValidationEnabled = ValidationUtility.IsValidationEnabled(HttpContext.Current);<br />
            if (isRequestValidationEnabled == true) {<br />
                ValidationUtility.EnableDynamicValidation(HttpContext.Current);<br />
            }<br />
            AddVersionHeader(httpContext);<br />
            RemoveOptionalRoutingParameters();<br />
            string controllerName = RequestContext.RouteData.GetRequiredString("controller");<br />
            factory = ControllerBuilder.GetControllerFactory();<br />
            controller = factory.CreateController(RequestContext, controllerName);<br />
            if (controller == null) {<br />
              throw new InvalidOperationException(String.Format(CultureInfo.CurrentCulture,MvcResources.ControllerBuilder_FactoryReturnedNull,factory.GetType(),controllerName));<br />
            }<br />
        }<br />
}</pre>
</div>
<p>⒂从以上可以看出：首先通过ControllerBuilder的静态方法GetControllerFactory获取到实现IControllerFactory接口的ControllerFactory，然后根据从上下文中的路由数据中拿到controller名称，并据此创建实现IController接口的Controller</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/417212/201406/190104521454195.png" /></p>
<p>Controller派生于ControllerBase, 而ControllerBase实现了IController接口。ControllerBase的部分源码如下：</p>
<div>
<pre class="prettyprint linenums">public abstract class ControllerBase : IController<br />
{<br />
    protected virtual void Execute(RequestContext requestContext)<br />
    {<br />
        if (requestContext == null)<br />
        {<br />
            throw new ArgumentNullException("requestContext");<br />
        }<br />
        if (requestContext.HttpContext == null)<br />
        {<br />
            throw new ArgumentException(<br />
              MvcResources.ControllerBase_CannotExecuteWithNullHttpContext,<br />
              "requestContext");<br />
        }<br />
        VerifyExecuteCalledOnce();<br />
        Initialize(requestContext);<br />
        using (ScopeStorage.CreateTransientScope())<br />
        {<br />
            ExecuteCore();<br />
        }<br />
    }<br />
    protected abstract void ExecuteCore();<br />
    ......<br />
}</pre>
</div>
<p>从中可以看成：<br />● 每次调用controller，都会执行基类ControllerBase的Execute()方法<br />● Execute()方法又会调用ExecuteCore()这个抽象方法<br />● ExecuteCore()这个抽象方法的实现被定义在Controller中<br />● 在Controller中的ExecuteCore()方法会调用ActionInvoker的InvokeAction()方法</p>
<p>⒃ActionInvoker激发Action方法</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/417212/201406/190104530046324.png" /></p>
<p>ActionInvoker实现了IActionInvoker接口：</p>
<div>
<pre class="prettyprint linenums">public interface IActionInvoker<br />
{<br />
  bool InvokeAction(ControllerContext controllerContext, string actionName);<br />
}</pre>
</div>
<p>MVC默认的ActionInvoker是ControllerActionInvoker。</p>
<p>在Controller类中，提供了类型为IActionInvoker的属性ActionInvoker，当执行ExecuteCore()方法时会让这个ActionInvoker调用InvokeAction()方法激发Action。如下：</p>
<div>
<pre class="prettyprint linenums">public class Controller<br />
{<br />
  ......<br />
  private IActionInvoker _actionInvoker;<br />
  public IActionInvoker ActionInvoker<br />
  {<br />
    get<br />
    {<br />
      if(_actionInvoker == null)<br />
      {<br />
        _actionInvoker = CreateActionInvoker();<br />
      }<br />
      return _actionInvoker;<br />
    }<br />
    set<br />
    {<br />
      _actionInvoker = value;<br />
    }<br />
  }

  protected virtual IActionInvoker CreateActionInvoker()<br />
  {<br />
    return new ControllerActionInvoker();<br />
  }

   public override void ExecuteCore()<br />
   {<br />
     ActionInvoker.InvokeAction(...);<br />
   }<br />
   .....<br />
}</pre>
</div>
<p>ActionInvoker在执行InvokeAction()方法时会需要有关Controller和Action的相关信息，实际上，Controller信息(比如Controller的名称、类型、包含的Action等)被封装在ControllerDescriptor这个类中，Action信息(比如Action的名称、参数、属性、过滤器等)被封装在ActionDescriptor中。</p>
<p>另外，ActionDescriptor还提供了一个FindAction()方法，用来找到需要被执行的Action。</p>
<p>⒄ActionInvoker在执行InvokeAction()方法返回ActionResult</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/417212/201406/190104539426010.png" /></p>
<p>ActionResult是一个抽象类：</p>
<div>
<pre class="prettyprint linenums">public abstract class ActionResult<br />
{<br />
  public abstract void ExecuteResult(ControllerContext context);<br />
}</pre>
</div>
<p>如果ActionResult是非ViewResult，比如JsonResult, ContentResult，这些内容将直接被输送到Response响应流中，显示给客户端；如果是ViewResult，就会进入下一个渲染视图环节。</p>
<p>⒅ViewEngine找到需要被渲染的视图</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/417212/201406/190104550047668.png" /></p>
<p>默认的有Razor View Engine和Web Form View Engine，实现IViewEngine接口。</p>
<p>IViewEngine接口方法：<br />● FindPartialView<br />● FindView<br />● ReleaseView</p>
<p>如果要创建自定义View Engine，只需要派生于VirtualPathProviderViewEngine这个类。</p>
<p>⒆View被加载成WebViewPage&lt;TModel&gt;类型，并渲染生成Html</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/417212/201406/190104561291113.png" /></p>
<p>调用ViewResult的ExecuteResult()方法，通过IView的Render()方法渲染成Html。</p>
<div>
<pre class="prettyprint linenums">public abstract class ViewResultBase : ActionResult<br />
{<br />
        public override void ExecuteResult(ControllerContext context)<br />
        {<br />
            if (context == null)<br />
            {<br />
                throw new ArgumentNullException("context");<br />
            }<br />
            if (String.IsNullOrEmpty(ViewName))<br />
            {<br />
                ViewName = context.RouteData.GetRequiredString("action");<br />
            }

            ViewEngineResult result = null;

            if (View == null)<br />
            {<br />
                //通过视图引擎获取到ViewEngineResult ，此时模板页面【aspx】被加载成了WebViewPage&lt;TModel&gt;<br />
                result = FindView(context);<br />
                View = result.View;<br />
            }

            TextWriter writer = context.HttpContext.Response.Output;<br />
            ViewContext viewContext = new ViewContext(context, View, ViewData, TempData, writer);<br />
            View.Render(viewContext, writer);

            if (result != null)<br />
            {<br />
                result.ViewEngine.ReleaseView(context, View);<br />
            }<br />
        }<br />
}</pre>
</div>
<p>ASP.NET MVC请求处理管道生命周期的19个关键环节系列包括：</p>
<h3><a href="http://www.cnblogs.com/darrenji/p/3795661.html" rel="external nofollow noreferrer">ASP.NET MVC请求处理管道生命周期的19个关键环节(1-6)</a></h3>
<h3><a href="http://www.cnblogs.com/darrenji/p/3795676.html" rel="external nofollow noreferrer">ASP.NET MVC请求处理管道生命周期的19个关键环节(7-12)</a></h3>
<h3><a href="http://www.cnblogs.com/darrenji/p/3795690.html" rel="external nofollow noreferrer">ASP.NET MVC请求处理管道生命周期的19个关键环节(13-19)</a></h3>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/3903649d.html">JavaScript 随机数</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ew01k8.html">通过rem编写自适应移动端要点</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlx3x1q.html">Java System&period;getProperty&lpar;&rpar;方法获取系统信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93exxwq.html">关于jQuery的一些实用代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mo4zjq.html">C语言程序设计50例&lpar;二）&lpar;经典收藏&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm26169.html">新Azure 服务仪表盘&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96orkwy9.html">linux lvm的操作手册&lowbar;pvcreate&lowbar;vgcreate&lowbar;lvcreate&lowbar;相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojkkvpq.html">《C&sol;C&plus;&plus;学习指南》 - 关于本书</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey4n4z9.html">设置角色遗留问题和为权限设置角色以及EasyUI Tabs的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj1zgxq.html">Nunit NMock Ncover单元测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1gx0gq.html">pwnable&period;kr col之write up</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgj2g8.html">rjs 合并压缩完 js 后 js 不压缩的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mlwmo8.html">DNA序列组装（贪婪算法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjo7e28.html">shell拼写检查，利用Linux字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojz2mlq.html">SpringDay01</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjr21g8.html">linux学习：文件处理相关命令用法整理&lpar;正则表达式&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e45gme9.html">通过Java构造参数列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyn11jq.html">MooFest POJ1990</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjwk409.html">Oracle使用笔记（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmeex09.html">Android Studio 修改Logcat的颜色</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49g7dv49.html">bootstrap分页插件--Bootstrap Paginator的使用&amp;amp&semi;AJAX版备份&lpar;可单独使用&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r270dq.html">new String（&OpenCurlyDoubleQuote;a&rdquo;）与String a&equals;&amp;quot&semi;a&amp;quot&semi;&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq17y22q.html">C语课设心得分享&lpar;三&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m5rxrq.html">IOS 周几转化数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvy7oxq.html">算法与数据结构实验题6&period;4 order （二叉树）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jog34q.html">db2 进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlr2okq.html">Java关键字&colon;transient&comma;strictfp和volatile简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4o2338.html">textfield设置左边距</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96r2z39.html">Sql Server 查询第30条数据到第40条记录数</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p46ek9.html">jquery 让select元素中的某个option被选中</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
